
import { _decorator, Component, Node, systemEvent, SystemEvent, view, PhysicsSystem2D, Contact2DType, Collider2D, Label, EPhysics2DDrawFlags } from 'cc';
const { ccclass, property } = _decorator;

/**
 * Predefined variables
 * Name = NewComponent
 * DateTime = Mon Oct 18 2021 17:04:21 GMT+0800 (中国标准时间)
 * Author = muxiandong
 * FileBasename = NewComponent.ts
 * FileBasenameNoExtension = NewComponent
 * URL = db://assets/NewComponent.ts
 * ManualUrl = https://docs.cocos.com/creator/3.3/manual/zh/
 *
 */
 
@ccclass('NewComponent')
export class NewComponent extends Component {
    
    @property(Node)
    touchNode !: Node;
    @property(Label)
    currentLabel !: Label;
    @property(Label)
    contactLabel !: Label;

    private debugDrawFlags : number = 0;

    onEnable () {
        // PhysicsSystem2D.instance.debugDrawFlags = this.debugDrawFlags | EPhysics2DDrawFlags.Shape;
    }

    onDisable () {
        // PhysicsSystem2D.instance.debugDrawFlags = this.debugDrawFlags;
    }

    start () {
        systemEvent.on(SystemEvent.EventType.MOUSE_DOWN, this._mouseDown, this);
        systemEvent.on(SystemEvent.EventType.MOUSE_UP, this._mouseUp, this);
        systemEvent.on(SystemEvent.EventType.MOUSE_MOVE, this._mouseMove, this);

        PhysicsSystem2D.instance.on(Contact2DType.BEGIN_CONTACT, this.onBeginContact, this);
        PhysicsSystem2D.instance.on(Contact2DType.END_CONTACT, this.onEndContact, this);
        this.debugDrawFlags = PhysicsSystem2D.instance.debugDrawFlags;

        // PhysicsSystem2D.instance.debugDrawFlags = EPhysics2DDrawFlags.Aabb | 
        //     EPhysics2DDrawFlags.Pair |
        //     EPhysics2DDrawFlags.CenterOfMass |
        //     EPhysics2DDrawFlags.Joint |
        //     EPhysics2DDrawFlags.Shape;

        // PhysicsSystem2D.instance.enable = true;
    }

    onBeginContact (a: Collider2D, b: Collider2D) {
        // console.log("onBeginContact:",a,b);
        this.contactLabel.string = "Is Contact: true";
    }

    onEndContact (a: Collider2D, b: Collider2D) {
        // console.log("onEndContact:",a,b);
        this.contactLabel.string = "Is Contact: false";
    }
    
    _mouseDown (evt) {
        console.log(evt);
    }

    _mouseUp (evt) {
        console.log(evt);
    }

    _mouseMove (evt) {
        let pos = evt.getUILocation();
        let winSize = view.getFrameSize();
        pos.x -= winSize.width / 2;
        pos.y -= winSize.height / 2;
        console.log(pos);
        this.currentLabel.string = `current:(${pos.x},${pos.y})`;

        this.touchNode.setPosition(pos.x, pos.y, 0);
    }
}
